-- MySQL dump 10.13  Distrib 5.1.37, for debian-linux-gnu (i486)
--
-- Host: localhost    Database: webpm
-- ------------------------------------------------------
-- Server version	5.1.37-1ubuntu5

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `assignments`
--

DROP TABLE IF EXISTS `assignments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `assignments` (
  `re_number` varchar(6) NOT NULL,
  `pr_number` varchar(6) NOT NULL,
  `re_hours` int(11) NOT NULL,
  KEY `fk_re_number` (`re_number`),
  KEY `fk_pr_number` (`pr_number`),
  CONSTRAINT `fk_pr_number` FOREIGN KEY (`pr_number`) REFERENCES `projects` (`pr_number`),
  CONSTRAINT `fk_re_number` FOREIGN KEY (`re_number`) REFERENCES `resources` (`re_number`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `assignments`
--

LOCK TABLES `assignments` WRITE;
/*!40000 ALTER TABLE `assignments` DISABLE KEYS */;
/*!40000 ALTER TABLE `assignments` ENABLE KEYS */;
UNLOCK TABLES;

DROP TABLE IF EXISTS `amounts`;
CREATE TABLE `amounts` (
  `pr_number` varchar(6) NOT NULL,
  `pr_amount` int(11) NOT NULL,
  KEY `fk_pr_number` (`pr_number`),
  CONSTRAINT `fk_pr_number_2` FOREIGN KEY (`pr_number`) REFERENCES `projects` (`pr_number`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `business_cases`
--

DROP TABLE IF EXISTS `business_cases`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `business_cases` (
  `bc_number` varchar(6) NOT NULL,
  `bc_name` varchar(50) NOT NULL,
  `bc_desc` varchar(500) NOT NULL,
  PRIMARY KEY (`bc_number`),
  KEY `bc_number` (`bc_number`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `business_cases`
--

LOCK TABLES `business_cases` WRITE;
/*!40000 ALTER TABLE `business_cases` DISABLE KEYS */;
INSERT INTO `business_cases` VALUES ('bc0001','bc1',' BC-1'),('bc0002','bc2',' BC-2'),('bc0008','bc8',' BC-8'),('bc0010','bc10',' bc-10'),('bc0012','bc12',' BC-12'),('bc0013','bc13',' BC-13'),('bc0014','bc14',' BC-14'),('bc0015','bc15',' BC-15'),('bc0016','bc16','BC-16'),('bc0017','bc17','bc-17'),('bc0018','bc18',' BC-18'),('bc0019','bc19',' BC-19'),('bc0020','bc20',' BC-20'),('bc0021','bc21',' BC-21'),('bc0022','bc22',' bc-22'),('bc0023','bc23',' BC-23'),('bc0024','bc24',' BC-24'),('bc0025','bc25',' BC-25'),('bc0026','bc26',' BC-26'),('bc0027','bc27',' BC-27'),('bc0028','bc28',' BC-28'),('bc0029','bc29',' BC-29'),('bc0030','bc30',' BC-30'),('bc0031','bc31',' BC-31'),('bc0032','bc32',' BC-32'),('bc0033','bc33',' BC-33'),('bc0034','bc34',' BC-34'),('bc0035','bc35',' bc-35'),('bc0036','bc36',' BC-36'),('bc0037','bc37',' bc-37'),('bc0038','bc38',' BC-38'),('bc0039','bc39',' BC-39'),('bc0040','bc40',' BC-40'),('bc0050','bc50',' BC-50'),('bc0097','bc97',' BC-97'),('bc0099','bc99',' BC-99'),('bc0100','bc100',' BC-100'),('bc0111','bc111',' BC-111'),('bc0113','bc113',' BC-113'),('bc3333','bcF',' BC-F'),('bc4589','bcZ',' BC-Z'),('bc5325','bc5325',' BC-5325'),('bc6666','bcD',' BC-D'),('bc6669','Sample business case',' Sample business case.'),('bc9191','bcC',' BC-C'),('bc9696','business case 9696',' BC-9696'),('bc9797','bc9797','BC-9797'),('bc9898','bcB',' BC-B'),('bc9999','bcA','BC-A');
/*!40000 ALTER TABLE `business_cases` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `projects`
--

DROP TABLE IF EXISTS `projects`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `projects` (
  `pr_number` varchar(6) NOT NULL,
  `pr_name` varchar(100) DEFAULT NULL,
  `pr_desc` varchar(500) DEFAULT NULL,
  `pr_status` varchar(16) DEFAULT NULL,
  `pr_start_date` date DEFAULT NULL,
  `pr_end_date` date DEFAULT NULL,
  `pr_manager` varchar(50) DEFAULT NULL,
  `pr_poc` varchar(50) DEFAULT NULL,
  `pr_sponsor` varchar(50) DEFAULT NULL,
  `pr_component` varchar(6) DEFAULT NULL,
  `pr_comment` varchar(500) DEFAULT NULL,
  `bc_number` varchar(6) NOT NULL,
  PRIMARY KEY (`pr_number`),
  KEY `pr_number` (`pr_number`),
  KEY `bc_number` (`bc_number`),
  CONSTRAINT `projects_ibfk_1` FOREIGN KEY (`bc_number`) REFERENCES `business_cases` (`bc_number`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `projects`
--

LOCK TABLES `projects` WRITE;
/*!40000 ALTER TABLE `projects` DISABLE KEYS */;
INSERT INTO `projects` VALUES ('pr0001','project 1',NULL,'Pending','2010-04-27','2010-04-27','resource_1','resource_1','bc0001',NULL,NULL,'bc0001'),('pr0002','project 2',NULL,'Pending','2010-04-27','2010-04-28','resource_1','resource_1','bc0002',NULL,NULL,'bc0008'),('pr0003','project 3',NULL,'Pending','2010-04-27','2010-04-28','resource_15','resource_15','bc0001',NULL,NULL,'bc0001'),('pr0009','project_9',NULL,'Pending','2010-04-26','2010-04-27','resource_1','resource_1','bc0001',NULL,NULL,'bc0002'),('pr0010','project_10',NULL,'Pending','2010-04-26','2010-04-27','resource_1','resource_1','bc0002',NULL,NULL,'bc0002'),('pr1000','project 1000',NULL,'Pending','2010-04-28','2010-04-27','resource_15','resource_15','bc0001',NULL,NULL,'bc0002'),('pr6669','Sample project',NULL,'Pending','2010-04-27','2010-04-28','resource_1','resource_1','bc6669',NULL,NULL,'bc6669');
/*!40000 ALTER TABLE `projects` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `resources`
--

DROP TABLE IF EXISTS `resources`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `resources` (
  `re_number` varchar(6) NOT NULL,
  `re_name` varchar(50) NOT NULL,
  `re_desc` varchar(500) DEFAULT NULL,
  PRIMARY KEY (`re_number`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `resources`
--

LOCK TABLES `resources` WRITE;
/*!40000 ALTER TABLE `resources` DISABLE KEYS */;
INSERT INTO `resources` VALUES ('re0015','resource_15',' RE-15'),('re0020','resource_20',' RE-20'),('re0021','resource_21',' RE-21'),('re6669','Sample resource','Sample resource.');
/*!40000 ALTER TABLE `resources` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `statuses`
--

DROP TABLE IF EXISTS `statuses`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `statuses` (
  `status` varchar(20) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `statuses`
--

LOCK TABLES `statuses` WRITE;
/*!40000 ALTER TABLE `statuses` DISABLE KEYS */;
INSERT INTO `statuses` VALUES ('Pending'),('Started'),('On Hold'),('Complete');
/*!40000 ALTER TABLE `statuses` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users` (
  `username` varchar(16) NOT NULL,
  `password` varchar(64) NOT NULL,
  `enabled` tinyint(1) NOT NULL,
  PRIMARY KEY (`username`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users`
--

LOCK TABLES `users` WRITE;
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
INSERT INTO `users` VALUES ('chris','*F720ABACACBD1D26B6904DC0011FFAFD1F2DBA7C',1),('mike','*811A2C4303C99FE4C9E7B6374423C8EBF0A77271',1),('ryan','*8DC81F46F004E99DD2347305BF897C973FD50956',1);
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2010-04-28 13:42:39
