/**
 * WebPM Security Filter 
 * mharris
 *
 * TODO:
 *
 * This class is not currently used, but is provided to ease implementation of
 * authz. functionality.
 *
 */

package webpmsec; 

import java.io.IOException; 
import java.security.Policy; 
import javax.servlet.Filter; 
import javax.servlet.FilterConfig; 
import javax.servlet.FilterChain; 
import javax.servlet.ServletRequest; 
import javax.servlet.ServletResponse; 
import javax.servlet.ServletException; 
import javax.servlet.http.HttpServletRequest; 
import javax.servlet.http.HttpServletResponse; 
import javax.servlet.http.HttpSession; 
import javax.security.auth.*; 
import javax.security.auth.login.LoginContext; 
import javax.security.auth.login.LoginException; 

public class webpmSecurityFilter implements Filter { 
	
	public void init(FilterConfig config) throws ServletException { 
		Policy orgPolicy = Policy.getPolicy (); 

		if (orgPolicy instanceof webpmPolicy) { 
			System.out.println("policy already applied"); 
		} else { 
			Policy.setPolicy(new webpmPolicy(orgPolicy));
			System.out.println("policy is not a webpmPolicy"); 
		}
	}

	public void destroy () { 
		// config = null; 
	}

	public void doFilter (ServletRequest sreq, ServletResponse sres, 
			FilterChain chain) throws IOException, ServletException 
	{
		System.out.println("Starting webpmSecurityFilter.doFilter"); 

		HttpServletResponse response = (HttpServletResponse) sres; 
		HttpServletRequest request = (HttpServletRequest) sreq; 

		HttpSession session = request.getSession (true);
		Subject subject = (Subject) session.getAttribute("javax.security.auth.subject"); 

		if (subject == null) { 
			subject = new Subject (); 
		}

		session.setAttribute("javax.security.auth.subject", subject); 

		LoginContext lc = null; 
		try { 
			lc = new LoginContext("webpm", subject, new webpmAcnCallbackHandler (request));
			System.out.println ( "established new login context" ); 
		} catch (LoginException le) { 
			le.printStackTrace(); 
			response.sendError (HttpServletResponse.SC_FORBIDDEN, request.getRequestURI());
			return; 
		}

		try { 
			lc.login();
		} catch (Exception e) { 
			System.out.println ( "Login failed: " + e ); 
			response.sendError (HttpServletResponse.SC_FORBIDDEN, request.getRequestURI()); 
			return;
		} 

		try { 
			System.out.println ( "Subject is " + lc.getSubject() ); 
			chain.doFilter (request, response); 
		} catch (SecurityException e) { 
			response.sendError (HttpServletResponse.SC_FORBIDDEN, request.getRequestURI()); 
		}

	}
}
