/** 
 * WebPM Business Case Mgr Servlet 
 * mharris, censign 
 *
 * TODO:
 *
 * database accesses are carried out under the DB username/password pair "mike"/"webpm", 
 *  these defaults should be changed according to site policy.  
 * 
 */ 

import java.io.IOException;
import java.util.Map; 
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.Connection; 
import java.sql.DriverManager; 
import java.sql.ResultSet; 
import java.sql.Statement; 
import com.mysql.jdbc.ResultSetMetaData;
import org.json.JSONArray; 
import org.json.JSONException;
import org.json.JSONObject; 

public class businessCaseMgr extends javax.servlet.http.HttpServlet 
	implements javax.servlet.Servlet 
{
	private Connection con; 

	public businessCaseMgr () { 
		super (); 

		String url = "jdbc:mysql://webpm/webpm"; 
		// TODO: replace w/Auth object (meh) 
		String user = "mike"; 
		String password = "webpm"; 

	  try {
      Class.forName ("com.mysql.jdbc.Driver");
      con  =  DriverManager.getConnection (url, user, password);
		} catch (Exception e) { 
			e.printStackTrace (); 
		}

	}

  /**
	 * This code is non essential; globalWrite () provides a global method for writing 
   * debugging/error messages to the response writer.  
   */ 
  private HttpServletResponse globalResponse = null;
  private void setGlobalResponse (HttpServletResponse r) { globalResponse = r; }
  private void globalWrite (String s) {
    if (globalResponse != null) {
      try { globalResponse.getWriter ().write (s); } catch (IOException neverMind) { }
    }
  }

	protected void doDelete (HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException
	{
		doPost (request, response); 
	} 

	protected void doGet (HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException
	{
		doPost (request, response); 
	} 

	protected void doPost (HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException
	{
		setGlobalResponse (response); 
		response.setContentType ("text/plain"); 

		String query = request.getParameter ("q"); 
		if (query == null) 
			query = ""; 

		if (query.equals ("get_name_store")) {                  // name store request OR 
			JSONObject nameStore = buildNameStore (); 
			response.getWriter ().write (nameStore.toString ()); 
	  } else if (! query.equals ("")) {                       // business case request OR 
			JSONObject businessCase = buildBusinessCase (query); 
			response.getWriter ().write (businessCase.toString ()); 
		} else {                                                // add new business case to db. 

      webpmBusinessCase thisBusinessCase = new webpmBusinessCase (request.getParameterMap ());
      if (thisBusinessCase.isValid ()) {
				if (saveData (thisBusinessCase) == 201) { 
					response.getWriter ().write (thisBusinessCase.bc_name); 
					response.setStatus (201); 
				} else { 
					response.getWriter ().write ("Oops!"); 
					response.setStatus (409); 
				} 
			} 

    }

		response.getWriter ().flush (); 
		response.getWriter ().close (); 
	} 

	private JSONObject buildNameStore () 
	{
		JSONObject nameObj = new JSONObject (); 
		JSONArray nameList = new JSONArray (); 

		String query = "SELECT bc_number,bc_name FROM business_cases"; 

		Statement s; 

		try { 
			s = con.createStatement (); 	
			ResultSet rs = s.executeQuery (query); 
			ResultSetMetaData rsmd = (ResultSetMetaData) rs.getMetaData (); 

			while (rs.next ()) { 
				JSONObject thisName = new JSONObject (); 
				//thisName.put ("type", "object"); 
				thisName.put ("bc_name", rs.getString ("BC_NAME")); 
				thisName.put ("bc_number", rs.getString ("BC_NUMBER")); 
				nameList.put (thisName); 
			} 

			nameObj.put ("identifier", "bc_number"); 
			nameObj.put ("items", nameList); 
		} catch (Exception e) {
			e.printStackTrace (); 
		/* } catch (JSONException e) { 
			e.printStackTrace (); */
		} 

		return nameObj; 
	}

	private JSONObject buildBusinessCase (String r) 
	{
		JSONObject bcObj = new JSONObject (); 
		JSONArray bcObjList = new JSONArray (); 

		String query = "SELECT * FROM business_cases WHERE bc_number = '" + r + "';"; 

		Statement s; 

		try { 
			s = con.createStatement (); 
			ResultSet rs = s.executeQuery (query); 
			ResultSetMetaData rsmd = (ResultSetMetaData) rs.getMetaData (); 

			while (rs.next ()) { 
				JSONObject thisBcObj = new JSONObject (); 
				thisBcObj.put ("type", "object"); 
				thisBcObj.put ("id", rs.getString ("BC_NUMBER")); 
				thisBcObj.put ("name", rs.getString ("BC_NAME")); 
				thisBcObj.put ("number", rs.getString ("BC_NUMBER")); 
				thisBcObj.put ("desc", rs.getString ("BC_DESC")); 
				bcObjList.put (thisBcObj); 
			} 	

			bcObj.put ("identifier", "id"); 
			bcObj.put ("items", bcObjList); 
		} catch (Exception e) { 
			e.printStackTrace (); 
		} 

		return bcObj; 
	} 

  private int saveData (webpmBusinessCase b) {

		if (b.isEdit) { 

		String query = "UPDATE business_cases SET bc_name = '" + b.bc_name + "', bc_desc = '" + b.bc_desc + "' WHERE bc_number = '" + b.bc_number + "';";

    Statement s;

    int stat = 0;
    try {
      s = con.createStatement ();
      stat = s.executeUpdate (query);
    } catch (Exception e) {
      //e.printStackTrace ();
      //globalWrite (e.getMessage ());
      return 409;
    }

		return 201; 

		} else { 

    String query = "INSERT INTO business_cases " +
      "(bc_name,bc_number,bc_desc) " +
      "VALUES (" +
      "'" + b.bc_name + "'," +
      "'" + b.bc_number + "'," +
      "'" + b.bc_desc + "');";

		Statement s; 

		int stat = 0; 
		try { 
			s = con.createStatement (); 
			stat = s.executeUpdate (query); 
		} catch (Exception e) { 
			return 409; // HTTP status code (conflict) 
			//e.printStackTrace (); 
		} 

		} 

		return 201; // HTTP status code (created) 
  }

  class webpmBusinessCase extends webpmData {

    String bc_name;
    String bc_number;
    String bc_desc;

		boolean isEdit = false; 

    webpmBusinessCase (Map raw_bc_data) {

			if (raw_bc_data.get ("edit_bc_name") != null) { 

			isEdit = true; 

     	bc_name           = ((String []) raw_bc_data.get ("edit_bc_name"))[0];
     	bc_number         = ((String []) raw_bc_data.get ("edit_bc_number"))[0];
     	bc_desc           = ((String []) raw_bc_data.get ("edit_bc_desc"))[0];

			} else { 

      bc_name           = ((String []) raw_bc_data.get ("new_bc_name"))[0];
      bc_number         = ((String []) raw_bc_data.get ("new_bc_number"))[0];
      bc_desc           = ((String []) raw_bc_data.get ("new_bc_desc"))[0];

      // optional fields
      if (bc_desc == null) bc_desc = "";

			} 
    }

    boolean isValid () {
      if (! noRestrictedCharacters (bc_name)) 
				return false; 
      if (! isAlphaNumeric (bc_number)) 
				return false; 
      if (! noRestrictedCharacters (bc_desc)) 
				return false; 

      return true;
    }

  } // webpmBusinessCase 

} // businessCaseMgr 

