/**
 * WebPM Project Manager class 
 * mharris, censign
 *
 * TODO:
 *
 * database accesses are carried out under the DB username/password pair "mike"/"webpm",
 *  these defaults should be changed according to site policy.
 *
 */

import java.io.IOException;
import java.util.Map; 
import java.util.LinkedList; 
import java.util.Set; 
import java.util.Iterator; 
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.Connection; 
import java.sql.DriverManager; 
import java.sql.ResultSet; 
import java.sql.Statement; 
import com.mysql.jdbc.ResultSetMetaData;
import org.json.JSONArray; 
import org.json.JSONException;
import org.json.JSONObject; 

public class projectMgr 
{
	private Connection con; 

  public String getVersion () { 
		return ("v1.0"); 
	} 

	public projectMgr () { 

		String url = "jdbc:mysql://webpm/webpm"; 
		// replace w/Auth object (meh) 
		String user = "mike"; 
		String password = "webpm"; 

	  try {
      Class.forName ("com.mysql.jdbc.Driver");
      con  =  DriverManager.getConnection (url, user, password);
		} catch (Exception e) { 
			e.printStackTrace (); 
		}

	}

  String buildAmountsList (String r)
  {
    JSONObject amtObj = new JSONObject ();
    JSONArray amtList = new JSONArray ();
 
    String query = "SELECT * FROM amounts WHERE pr_number = '" + r + "';";
   
    Statement s;
   
    String ret = "";
   
    try {
      s = con.createStatement ();
      ResultSet rs = s.executeQuery (query);
      ResultSetMetaData rsmd = (ResultSetMetaData) rs.getMetaData ();

      while (rs.next ()) {

        JSONObject thisAmount = new JSONObject ();
        thisAmount.put ("type", "object");
        thisAmount.put ("id", rs.getString ("PR_NUMBER"));
        thisAmount.put ("amount", rs.getString ("PR_AMOUNT"));
        thisAmount.put ("year", rs.getString ("PR_YEAR"));
        amtList.put (thisAmount);

      }

      amtObj.put ("identifier", "id");
      amtObj.put ("items", amtList);
    } catch (Exception e) {
      //e.printStackTrace ();
    }

    return amtObj.toString ();

  }

	String buildProjectList (String r) 
	{
		JSONObject prlObj = new JSONObject (); 
		JSONArray prlList = new JSONArray (); 

		String query = "SELECT *,1 AS sort_col FROM projects WHERE bc_number = '" + r + "';"; 

		Statement s; 

		String ret = ""; 

		try { 
			s = con.createStatement (); 
			ResultSet rs = s.executeQuery (query); 
			ResultSetMetaData rsmd = (ResultSetMetaData) rs.getMetaData (); 

			while (rs.next ()) { 

				JSONObject thisProject = new JSONObject (); 
				thisProject.put ("type", "object"); 
				thisProject.put ("id", rs.getString ("PR_NUMBER")); 
				thisProject.put ("name", rs.getString ("PR_NAME")); 
				thisProject.put ("number", rs.getString ("PR_NUMBER")); 
				thisProject.put ("manager", rs.getString ("PR_MANAGER")); 
				thisProject.put ("poc", rs.getString ("PR_POC")); 
				thisProject.put ("sponsor", rs.getString ("PR_SPONSOR")); 
				thisProject.put ("sponsoring_component", rs.getString ("PR_SPONSORING_COMPONENT")); 
				thisProject.put ("start_date", rs.getString ("PR_START_DATE")); 
				thisProject.put ("end_date", rs.getString ("PR_END_DATE")); 
				thisProject.put ("status", rs.getString ("PR_STATUS"));
				thisProject.put ("desc", rs.getString ("PR_DESC")); 

				Statement t = con.createStatement (); 
				String query_2 = "SELECT SUM(re_hours) TOTAL_HOURS FROM assignments WHERE pr_number = '" + rs.getString ("PR_NUMBER") + "';"; 
				ResultSet rs_2 = t.executeQuery (query_2); 
				rs_2.next (); 
				thisProject.put ("hours", rs_2.getString ("TOTAL_HOURS")); 

				Statement u = con.createStatement (); 
				String query_3 = "SELECT SUM(pr_amount) TOTAL_AMOUNT FROM amounts WHERE pr_number = '" + rs.getString ("PR_NUMBER") + "';"; 
				ResultSet rs_3 = t.executeQuery (query_3); 
				rs_3.next (); 
				thisProject.put ("amount", rs_3.getString ("TOTAL_AMOUNT")); 
				
				prlList.put (thisProject); 

			} 

			prlObj.put ("identifier", "id"); 
			prlObj.put ("items", prlList); 
		} catch (Exception e) { 
			return e.getMessage (); 
		} 

		return prlObj.toString (); 
	} 

	String buildProject (String r)
	{
		JSONObject prObj = new JSONObject ();
		JSONArray prObjList = new JSONArray ();

		String query = "SELECT * FROM projects WHERE pr_number = '" + r + "';";

		String ret = ""; 

		Statement s;

		try {
			s = con.createStatement ();
			ResultSet rs = s.executeQuery (query);
			ResultSetMetaData rsmd = (ResultSetMetaData) rs.getMetaData ();

			while (rs.next ()) {
				JSONObject thisPrObj = new JSONObject ();
				thisPrObj.put ("type", "object");
				thisPrObj.put ("id", rs.getString ("PR_NUMBER"));
				thisPrObj.put ("name", rs.getString ("PR_NAME"));
				thisPrObj.put ("number", rs.getString ("PR_NUMBER"));
				thisPrObj.put ("manager", rs.getString ("PR_MANAGER"));
				thisPrObj.put ("poc", rs.getString ("PR_POC"));
				thisPrObj.put ("sponsor", rs.getString ("PR_SPONSOR"));
				thisPrObj.put ("sponsoring_component", rs.getString ("PR_SPONSORING_COMPONENT")); 
				thisPrObj.put ("start_date", rs.getString ("PR_START_DATE"));
				thisPrObj.put ("end_date", rs.getString ("PR_END_DATE"));
				thisPrObj.put ("status", rs.getString ("PR_STATUS")); 
				thisPrObj.put ("bc_number", rs.getString ("BC_NUMBER")); 
				thisPrObj.put ("desc", rs.getString ("PR_DESC")); 

				Statement t = con.createStatement (); 
				String query_2 = "SELECT SUM(re_hours) TOTAL_HOURS FROM assignments WHERE pr_number = '" + r + "';"; 
				ResultSet rs_2 = t.executeQuery (query_2); 
				rs_2.next (); 
				thisPrObj.put ("hours", rs_2.getString ("TOTAL_HOURS")); 

				Statement u = con.createStatement (); 
				String query_3 = "SELECT SUM(pr_amount) TOTAL_AMOUNT FROM amounts WHERE pr_number = '" + r + "';"; 
				ResultSet rs_3 = t.executeQuery (query_3); 
				rs_3.next (); 
				thisPrObj.put ("amount", rs_3.getString ("TOTAL_AMOUNT")); 

				Statement v = con.createStatement (); 
				String query_4 = "SELECT bc_name FROM business_cases WHERE bc_number = '" + rs.getString ("BC_NUMBER") + "';"; 
				ResultSet rs_4 = t.executeQuery (query_4); 
				rs_4.next (); 

				/* Statement w = con.createStatement (); 
				String query_5 = "SELECT * FROM amounts WHERE pr_number = '" + r + "';"; 
				ResultSet rs_5 = w.executeQuery (query_5); 
				while (rs_5.next ()) { 
					thisPrObj.put (rs_5.getString ("PR_YEAR"), rs_5.getString ("PR_AMOUNT")); 
				} 

				Statement x = con.createStatement (); 
				String query_6 = "SELECT * FROM assignments WHERE pr_number = '" + r + "';"; 
				ResultSet rs_6 = x.executeQuery (query_6); 
				while (rs_6.next ()) { 
					thisPrObj.put (rs_6.getString ("RE_NUMBER"), rs_6.getString ("RE_HOURS")); 
				} */ 

				//thisPrObj.put ("bc_number", rs_4.getString ("bc_name")); 

				prObjList.put (thisPrObj);
			}

			prObj.put ("identifier", "id");
			prObj.put ("items", prObjList);

			ret = prObj.toString (); 
		} catch (Exception e) {
			//e.printStackTrace ();
			ret = e.getMessage (); 
		}

		//return prObj.toString ();
		return ret; 
	}

	JSONObject buildNameStore () 
	{
		JSONObject nameObj = new JSONObject (); 
		JSONArray nameList = new JSONArray (); 

		String query = "SELECT pr_number,pr_name FROM projects"; 

		Statement s; 

		try { 
			s = con.createStatement (); 	
			ResultSet rs = s.executeQuery (query); 
			ResultSetMetaData rsmd = (ResultSetMetaData) rs.getMetaData (); 

			while (rs.next ()) { 
				JSONObject thisName = new JSONObject (); 
				//thisName.put ("type", "object"); 
				thisName.put ("pr_name", rs.getString ("PR_NAME")); 
				thisName.put ("pr_number", rs.getString ("PR_NUMBER")); 
				nameList.put (thisName); 
			} 

			nameObj.put ("identifier", "pr_number"); 
			nameObj.put ("items", nameList); 
		} catch (Exception e) {
			e.printStackTrace (); 
		/* } catch (JSONException e) { 
			e.printStackTrace (); */
		} 

		return nameObj; 
	}

	JSONObject buildStatusStore () 
	{
		JSONObject statusObj = new JSONObject (); 
		JSONArray statusList = new JSONArray (); 

		String query = "SELECT status FROM statuses;";

		Statement s; 

		try { 
			s = con.createStatement (); 
			ResultSet rs = s.executeQuery (query); 
			ResultSetMetaData rsmd = (ResultSetMetaData) rs.getMetaData (); 

			while (rs.next ()) { 
				JSONObject thisStatus = new JSONObject (); 
				thisStatus.put ("st_name", rs.getString ("STATUS")); 
				statusList.put (thisStatus); 
			} 

			statusObj.put ("identifier", "st_name"); 
			statusObj.put ("items", statusList); 
		} catch (Exception e) { 
			e.printStackTrace (); 
		/* } catch (JSONException e) { 
			e.printStackTrace (); */ 
		} 

		return statusObj; 
	} 

	int saveData (webpmProject p)
	{

		if (p.isEdit) { 

		String query = "UPDATE projects SET " + 
			"pr_name = '" + p.pr_name + "'," + 
			"bc_number = '" + p.pr_business_case + "'," + 
			"pr_manager = '" + p.pr_mgr + "'," + 
			"pr_poc = '" + p.pr_poc + "'," + 
			"pr_sponsor = '" + p.pr_sponsor + "'," + 
			"pr_start_date = '" + p.pr_start_date + "'," + 
			"pr_end_date = '" + p.pr_end_date + "'," + 
			"pr_status = '" + p.pr_status + "'," + 
			"pr_desc = '" + p.pr_desc + "'," + 
			"pr_sponsoring_component = '" + p.pr_sponsoring_component + "'" + 
			"WHERE pr_number = '" + p.pr_number + "';";  

		Statement s;

		int stat = 0;
		try {
			s = con.createStatement ();
			stat = s.executeUpdate (query);
		} catch (Exception e) {
			return 409; 
			//return (e.getMessage ());
		}

		return 201; 

		} else { 

		String query = "INSERT INTO projects " + 
			"(pr_name,pr_number,bc_number,pr_manager,pr_poc,pr_sponsor,pr_start_date,pr_end_date,pr_status,pr_desc,pr_sponsoring_component) " + 
			"VALUES (" + 
			"'" + p.pr_name + "'," +
			"'" + p.pr_number + "'," + 
			"'" + p.pr_business_case + "'," + 
			"'" + p.pr_mgr + "'," + 
			"'" + p.pr_poc + "'," + 
			"'" + p.pr_sponsor + "'," + 
			"'" + p.pr_start_date + "'," + 
			"'" + p.pr_end_date + "'," + 
			"'" + p.pr_status + "'," + 
			"'" + p.pr_desc + "'," + 
			"'" + p.pr_sponsoring_component + "');"; 

		Statement s;

		int stat = 0;
		try {
			s = con.createStatement ();
			stat = s.executeUpdate (query);
		} catch (Exception e) {
			return 409; 
			//return (e.getMessage ());
		}

		// update amounts 

		for (webpmProject.webpmFundingAlloc fA : p.getFundingAlloc ()) { 
			query = "INSERT INTO amounts " + 
				"VALUES ('" + p.pr_number + "','" + fA.amount + "','" + fA.year + "');";

			Statement t; 
			try { 
				t = con.createStatement (); 
				stat = t.executeUpdate (query); 
			} catch (Exception e) { 
				return 409; 
			} 
		} 

		// update assignments 

		for (webpmProject.webpmResourceAlloc rA : p.getResourceAlloc ()) { 
			query = "INSERT INTO assignments " + 
				"VALUES ('" + rA.reId + "','" + p.pr_number + "','" + rA.hours + "');";

			Statement t; 
			try { 
				t = con.createStatement (); 
				stat = t.executeUpdate (query); 
			} catch (Exception e) { 
				return 409; 
			} 
		} 

		} 

		return 201; 
	}

	public class webpmProject extends webpmData { 

		String pr_name; 
		String pr_number; 
		String pr_business_case; 
		String pr_mgr; 
		String pr_poc; 
		String pr_sponsor; 
		String pr_sponsoring_component; 
		String pr_start_date; 
		String pr_end_date; 
		String pr_status; 
		String pr_desc; 

		LinkedList<webpmResourceAlloc> resourceList; 
		LinkedList<webpmFundingAlloc> amountsList; 

		class webpmFundingAlloc { 
			int year; 
			double amount; 

			webpmFundingAlloc (int y, double a) { 
				year =  y; 
				amount = a; 				
			}
		} 

		class webpmResourceAlloc { 
			String reId; 
			int hours; 

			webpmResourceAlloc (String r, int h) { 
				reId = r; 
				hours = h; 
			} 
		} 

		LinkedList<webpmResourceAlloc> getResourceAlloc () { return resourceList; } 
		LinkedList<webpmFundingAlloc> getFundingAlloc () { return amountsList; } 

		boolean isEdit = false; 

		webpmProject (Map raw_pr_data) {

			if (raw_pr_data.get ("edit_pr_name") != null) { 

			isEdit = true; 

			pr_name 					= ((String []) raw_pr_data.get ("edit_pr_name"))[0]; 
			pr_number					= ((String []) raw_pr_data.get ("edit_pr_number"))[0];
			pr_business_case	= ((String []) raw_pr_data.get ("edit_pr_business_case"))[0]; 
			pr_mgr						= ((String []) raw_pr_data.get ("edit_pr_mgr"))[0]; 
			pr_poc						= ((String []) raw_pr_data.get ("edit_pr_poc"))[0]; 
			pr_sponsor				= ((String []) raw_pr_data.get ("edit_pr_sponsor"))[0]; 

			pr_sponsoring_component				= ((String []) raw_pr_data.get ("edit_pr_sponsoring_component"))[0]; 

			pr_start_date			= ((String []) raw_pr_data.get ("edit_pr_start_date"))[0]; 
			pr_end_date				= ((String []) raw_pr_data.get ("edit_pr_end_date"))[0]; 
			pr_status					= ((String []) raw_pr_data.get ("edit_pr_status"))[0];
			pr_desc						= ((String []) raw_pr_data.get ("edit_pr_desc"))[0]; 

			/** 
			 * Note: We didn't add functionality to edit funding/resource alloc. for an existing project. 
			 *  Otherwise, it would go here. 
			 */ 

			} else { 

			pr_name 					= ((String []) raw_pr_data.get ("new_pr_name"))[0]; 
			pr_number					= ((String []) raw_pr_data.get ("new_pr_number"))[0];
			pr_business_case	= ((String []) raw_pr_data.get ("new_pr_business_case"))[0]; 
			pr_mgr						= ((String []) raw_pr_data.get ("new_pr_mgr"))[0]; 
			pr_poc						= ((String []) raw_pr_data.get ("new_pr_poc"))[0]; 
			pr_sponsor				= ((String []) raw_pr_data.get ("new_pr_sponsor"))[0]; 

			pr_sponsoring_component				= ((String []) raw_pr_data.get ("new_pr_sponsoring_component"))[0]; 

			pr_start_date			= ((String []) raw_pr_data.get ("new_pr_start_date"))[0]; 
			pr_end_date				= ((String []) raw_pr_data.get ("new_pr_end_date"))[0]; 
			pr_status					= ((String []) raw_pr_data.get ("new_pr_status"))[0];
			pr_desc						= ((String []) raw_pr_data.get ("new_pr_desc"))[0]; 

			Set s = raw_pr_data.keySet (); 
			Iterator i = s.iterator (); 
			amountsList = new LinkedList<webpmFundingAlloc> (); 
			resourceList = new LinkedList<webpmResourceAlloc> (); 

			while (i.hasNext ()) { 

				String nextKey = (String) i.next (); 
				if (nextKey.contains ("_amt")) { 
					int year = Integer.parseInt (nextKey.substring (0, nextKey.indexOf ('_'))); 
					double amount = Double.parseDouble (((String []) raw_pr_data.get (nextKey))[0]); 
					amountsList.add (new webpmFundingAlloc (year, amount)); 
				} else if (nextKey.contains ("_hrs")) { 
					String reId = nextKey.substring (0, nextKey.indexOf ('_')); 
					int hours = Integer.parseInt (((String []) raw_pr_data.get (nextKey))[0]); 
					resourceList.add (new webpmResourceAlloc (reId, hours)); 
				} 

			} 

			// optional fields 
			if (pr_mgr == null) pr_mgr = ""; 
			if (pr_poc == null) pr_poc = ""; 
			if (pr_sponsor == null) pr_sponsor = ""; 
			if (pr_sponsoring_component == null) pr_sponsoring_component = ""; 
			if (pr_start_date == null) pr_start_date = ""; 
			if (pr_end_date == null) pr_end_date = ""; 
			if (pr_status == null) pr_status = ""; 
			if (pr_desc == null) pr_desc = ""; 

			} 

		}

		boolean isValid () { 
			if (! noRestrictedCharacters (pr_name)) return false; 
			if (! isAlphaNumeric (pr_business_case)) return false; 
			if (! noRestrictedCharacters (pr_mgr)) return false; 
			if (! noRestrictedCharacters (pr_poc)) return false; 
			if (! noRestrictedCharacters (pr_sponsor)) return false; 
			if (! noRestrictedCharacters (pr_sponsoring_component)) return false; 
			if (! noRestrictedCharacters (pr_start_date)) return false; 
			if (! noRestrictedCharacters (pr_end_date)) return false; 
			if (! noRestrictedCharacters (pr_status)) return false; 
			if (! noRestrictedCharacters (pr_desc)) return false; 

			if (! isEdit) {
				if (! isAlphaNumeric (pr_number)) return false; 
			} 

			return true;
		} 

	} // webpmProject 

} // projectMgr 

