/**
 * WebPM Project Mgr Servlet
 * mharris, censign
 *
 * TODO:
 *
 * database accesses are carried out under the DB username/password pair "mike"/"webpm",
 *  these defaults should be changed according to site policy.
 *
 */

import java.io.IOException;
import java.util.Map; 
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.Connection; 
import java.sql.DriverManager; 
import java.sql.ResultSet; 
import java.sql.Statement; 
import com.mysql.jdbc.ResultSetMetaData;
import org.json.JSONArray; 
import org.json.JSONException;
import org.json.JSONObject; 

/**
 * The projectMgrSvr class uses the projectMgr class to do the work of managing 
 * projects; this class simply provides the necessary servlet linkage. 
 */ 
public class projectMgrSvr extends javax.servlet.http.HttpServlet 
	implements javax.servlet.Servlet
{
	projectMgr p; 

	public projectMgrSvr () { 
		super (); 

		p = new projectMgr (); 
	}

	protected void doGet (HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException
	{
		doPost (request, response); 
	} 

	protected void doPost (HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException
	{
		response.setContentType ("text/plain"); 

		// projectMgrSvr?a=<projectId> returns yearly funding data in JSON fmt.
		String query = request.getParameter ("a"); 
		if (query != null) { 
			String amountsList = p.buildAmountsList (query); 
			response.getWriter ().write (amountsList); 
		} else { 

		query = ""; 

		// projectMgrSvr?b=<businessCaseId> returns all projects associated with a 
    // given BC in JSON fmt. 
		query = request.getParameter ("b"); 
		if (query != null) { 
			String projectList = p.buildProjectList (query); 
			//response.getWriter ().write (query); 	
			response.getWriter ().write (projectList); 	
		} else { 

		query = ""; 

		query = request.getParameter ("q"); 
		if (query == null) 
			query = ""; 

		// a "name store" request returns name data for all projects in the database 
    // (used for populating lists of all projects where necessary) 
		if (query.equals ("get_name_store")) { 

			JSONObject nameStore = p.buildNameStore (); 
			response.getWriter ().write (nameStore.toString ()); 

		// a "status store" request returns all possible projects statuses 
		} else if (query.equals ("get_status_store")) { 

			JSONObject statusStore = p.buildStatusStore (); 
			response.getWriter ().write (statusStore.toString ()); 

		} else if ( ! query.equals ("")) { 

			//JSONObject project = p.buildProject (query);
			String project = p.buildProject (query);
      response.getWriter ().write (project);

		} else { // else default action for post is to add new proj. to db.. 

			projectMgr.webpmProject thisProject = p.new webpmProject (request.getParameterMap ()); 
			if (thisProject.isValid ()) { 
				if (p.saveData (thisProject) == 201) { 
					response.getWriter ().write (thisProject.pr_name); 
					response.setStatus (201); 
				} else { 
					response.getWriter ().write ("Oops!"); 
					response.setStatus (409); 
				} 
			} 

/*
			response.getWriter ().write (thisProject.pr_name + "<br>"); 
			response.getWriter ().write (thisProject.pr_number + "<br>"); 
			response.getWriter ().write (thisProject.pr_business_case + "<br>"); 
			response.getWriter ().write (thisProject.pr_mgr + "<br>"); 
			response.getWriter ().write (thisProject.pr_poc + "<br>"); 
			response.getWriter ().write (thisProject.pr_sponsor + "<br>"); 
			response.getWriter ().write (thisProject.pr_start_date + "<br>"); 
			response.getWriter ().write (thisProject.pr_end_date + "<br>"); 
			response.getWriter ().write (thisProject.pr_status + "<br>"); 
*/
		}

		} 

		} 

		response.getWriter ().flush (); 
		response.getWriter ().close (); 
	} 

} // projectMgrSvr

