/**
 * WebPM Resource Mgr Servlet
 * mharris, censign
 *
 * TODO:
 *
 * database accesses are carried out under the DB username/password pair "mike"/"webpm",
 *  these defaults should be changed according to site policy.
 *
 */

import java.io.IOException;
import java.util.Map; 
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.Connection; 
import java.sql.DriverManager; 
import java.sql.ResultSet; 
import java.sql.Statement; 
import com.mysql.jdbc.ResultSetMetaData;
import org.json.JSONArray; 
import org.json.JSONException;
import org.json.JSONObject; 

public class resourceMgr extends javax.servlet.http.HttpServlet 
	implements javax.servlet.Servlet
{
	private Connection con; 

	public resourceMgr () { 
		super (); 

		String url = "jdbc:mysql://webpm/webpm"; 
		// replace w/Auth object (meh) 
		String user = "mike"; 
		String password = "webpm"; 

	  try {
      Class.forName ("com.mysql.jdbc.Driver");
      con  =  DriverManager.getConnection (url, user, password);
		} catch (Exception e) { 
			e.printStackTrace (); 
		}

	}

  private HttpServletResponse globalResponse = null;
  private void setGlobalResponse (HttpServletResponse r) { globalResponse = r; }
  private void globalWrite (String s) {
    if (globalResponse != null) {
      try { globalResponse.getWriter ().write (s); } catch (IOException neverMind) { }
    }
  }

	protected void doGet (HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException
	{
		doPost (request, response); 
	} 

	protected void doPost (HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException
	{
		setGlobalResponse (response); 

		response.setContentType ("text/plain"); 

		String query = request.getParameter ("a"); 
		if (query != null) { 
			String assignmentList = buildAssignmentList (query); 
			response.getWriter ().write (assignmentList); 
		} else { 

		query = request.getParameter ("p"); 
		if (query != null) { 
			String resourceList = buildResourceList (query); 
			//response.getWriter ().write (query); 
			response.getWriter ().write (resourceList); 
		} else { 

		query = ""; 

    query = request.getParameter ("q");
    if (query == null)
      query = "";

    if (query.equals ("get_name_store")) { 
      JSONObject nameStore = buildNameStore ();
      response.getWriter ().write (nameStore.toString ());
		} else if (! query.equals ("")) { 
			JSONObject resource = buildResource (query); 
			response.getWriter ().write (resource.toString ());
    } else { 

			webpmResource thisResource = new webpmResource (request.getParameterMap ());
			if (thisResource.isValid ()) {
				if (saveData (thisResource) == 201) { 
					response.getWriter ().write (saveData (thisResource));
					response.setStatus (201); 
				} else { 
					response.getWriter ().write ("Oops!"); 
					response.setStatus (409); 
				} 
			} 

		} // "q" 

		} // "p" 

		} // "a" 

		response.getWriter ().flush (); 
		response.getWriter ().close (); 
	} 

	private String buildResourceList (String r) 
	{
    JSONObject relObj = new JSONObject ();
    JSONArray relList = new JSONArray (); 
  
		String query = "SELECT * FROM resources WHERE re_number in (SELECT re_number FROM assignments WHERE pr_number = '" + r + "');"; 
    
    Statement s;
    
    String ret = "";
    
    try {
      s = con.createStatement ();
      ResultSet rs = s.executeQuery (query);
      ResultSetMetaData rsmd = (ResultSetMetaData) rs.getMetaData ();
      
      while (rs.next ()) { 

      	JSONObject thisResource = new JSONObject ();
      	thisResource.put ("type", "object"); 
      	thisResource.put ("id", rs.getString ("RE_NUMBER"));
      	thisResource.put ("name", rs.getString ("RE_NAME"));
      	thisResource.put ("number", rs.getString ("RE_NUMBER"));

        Statement t = con.createStatement ();
        String query_2 = "SELECT re_hours FROM assignments WHERE pr_number = '" + r + "';";
        ResultSet rs_2 = t.executeQuery (query_2);
        rs_2.next ();
        thisResource.put ("hours", rs_2.getString ("RE_HOURS"));

      	relList.put (thisResource); 

			} 
        
      relObj.put ("identifier", "id"); 
      relObj.put ("items", relList);
    } catch (Exception e) { 
      //e.printStackTrace ();
    }
    
		//return query;  
    return relObj.toString (); 

	}

	private String buildAssignmentList (String r) 
	{
		JSONObject assObj = new JSONObject (); 
		JSONArray assList = new JSONArray (); 

		String query = "SELECT * FROM projects WHERE pr_number in (SELECT pr_number from assignments WHERE re_number = '" + r + "');"; 

		Statement s; 

		String ret = ""; 

	  try {
      s = con.createStatement ();
      ResultSet rs = s.executeQuery (query);
      ResultSetMetaData rsmd = (ResultSetMetaData) rs.getMetaData ();

      while (rs.next ()) { 

      	JSONObject thisAssignment = new JSONObject ();
      	thisAssignment.put ("type", "object");
      	thisAssignment.put ("id", rs.getString ("PR_NUMBER"));
				thisAssignment.put ("name", rs.getString ("PR_NAME")); 
				thisAssignment.put ("number", rs.getString ("PR_NUMBER")); 
				//thisAssignment.put ("hours", ... ); 

        Statement t = con.createStatement ();
        String query_2 = "SELECT re_hours FROM assignments WHERE pr_number = '" + rs.getString ("PR_NUMBER") + "';";
        ResultSet rs_2 = t.executeQuery (query_2);
        rs_2.next ();
        thisAssignment.put ("hours", rs_2.getString ("RE_HOURS"));

      	assList.put (thisAssignment);

			} 

      assObj.put ("identifier", "id");
      assObj.put ("items", assList);
    } catch (Exception e) {
      //e.printStackTrace ();
    }

    return assObj.toString ();
	} 
	

	private JSONObject buildResource (String r) 
	{
    JSONObject reObj = new JSONObject ();
    JSONArray reObjList = new JSONArray ();

    String query = "SELECT * FROM resources WHERE re_number = '" + r + "';";
  
    Statement s;
    
    try { 
      s = con.createStatement ();
      ResultSet rs = s.executeQuery (query);
      ResultSetMetaData rsmd = (ResultSetMetaData) rs.getMetaData ();

      while (rs.next ()) {
        JSONObject thisReObj = new JSONObject ();
        thisReObj.put ("type", "object");
        thisReObj.put ("id", rs.getString ("RE_NUMBER"));
        thisReObj.put ("name", rs.getString ("RE_NAME"));
        thisReObj.put ("number", rs.getString ("RE_NUMBER"));
        thisReObj.put ("desc", rs.getString ("RE_DESC"));

        reObjList.put (thisReObj);
      }

      reObj.put ("identifier", "id");
      reObj.put ("items", reObjList);
    } catch (Exception e) {
      e.printStackTrace ();
    }

    return reObj;

	}

	private JSONObject buildNameStore () 
	{
		JSONObject nameObj = new JSONObject (); 
		JSONArray nameList = new JSONArray (); 

		String query = "SELECT re_number,re_name FROM resources"; 

		Statement s; 

		try { 
			s = con.createStatement (); 	
			ResultSet rs = s.executeQuery (query); 
			ResultSetMetaData rsmd = (ResultSetMetaData) rs.getMetaData (); 

			while (rs.next ()) { 
				JSONObject thisName = new JSONObject (); 
				//thisName.put ("type", "object"); 
				thisName.put ("re_name", rs.getString ("RE_NAME")); 
				thisName.put ("re_number", rs.getString ("RE_NUMBER")); 
				nameList.put (thisName); 
			} 

			nameObj.put ("identifier", "re_number"); 
			nameObj.put ("items", nameList); 
		} catch (Exception e) {
			e.printStackTrace (); 
		/* } catch (JSONException e) { 
			e.printStackTrace (); */
		} 

		return nameObj; 
	}

  private int saveData (webpmResource r)
	{

		if (r.isEdit) { 

		String query = "UPDATE resources SET re_name = '" + r.re_name + "', re_desc = '" + r.re_desc + "' WHERE re_number = '" + r.re_number + "';"; 

    Statement s;

    int stat = 0;
    try {
      s = con.createStatement ();
      stat = s.executeUpdate (query);
    } catch (Exception e) {
      //e.printStackTrace ();
			//globalWrite (e.getMessage ()); 
			return 409; 
    }

		return 201; 

		} else { 

		// resource table update 

    String query = "INSERT INTO resources " +
      "(re_name,re_number,re_desc) " +
      "VALUES (" +
      "'" + r.re_name + "'," +
      "'" + r.re_number + "'," +
      "'" + r.re_desc + "');";

    Statement s;

    int stat = 0;
    try {
      s = con.createStatement ();
      stat = s.executeUpdate (query);
    } catch (Exception e) {
      //e.printStackTrace ();
			//globalWrite (e.getMessage ()); 
			return 409; 
    }

		// assignments table update 

		query = "INSERT INTO assignments " + 
			"(re_number,pr_number,re_hours) " + 
			"VALUES (" + 
			"'" + r.re_number + "'," + 
			"'" + r.pr_number + "'," + 
			"'" + r.re_hours + "');"; 

		//globalWrite (query); 

		Statement t; 

		stat = 0; 
		try { 
			t = con.createStatement (); 
			stat = t.executeUpdate (query); 
		} catch (Exception e) { 
			//globalWrite (e.getMessage ());
			return 409; 
			//e.printStackTrace (); 
		} 

		} // ! isEdit 

		return 201; 
    //return r.re_number;
    //return query;
  }

  class webpmResource extends webpmData {

    String re_name;
    String re_number;
		String pr_number; 
		String re_hours; 
    String re_desc;

		boolean isEdit = false; 

    webpmResource (Map raw_re_data) {

			if (raw_re_data.get ("edit_re_name") != null) { 

				isEdit = true; 

      	re_name           = ((String []) raw_re_data.get ("edit_re_name"))[0];
				re_number					= ((String []) raw_re_data.get ("edit_re_number"))[0]; 
      	re_desc           = ((String []) raw_re_data.get ("edit_re_desc"))[0];

			} else { 

      	re_name           = ((String []) raw_re_data.get ("new_re_name"))[0];
      	re_number         = ((String []) raw_re_data.get ("new_re_number"))[0];
				pr_number					= ((String []) raw_re_data.get ("new_re_project"))[0]; 
				re_hours					= ((String []) raw_re_data.get ("new_re_hours"))[0]; 
      	re_desc           = ((String []) raw_re_data.get ("new_re_desc"))[0];

      	// optional fields
      	if (re_desc == null) re_desc = "";

			} 

    }

    boolean isValid () {
      if (! isAlphaNumeric (re_name)) return false;
      if (! isAlphaNumeric (re_number)) return false;
      if (! noRestrictedCharacters (re_desc)) return false;

			if (! isEdit) {
				if (! isAlphaNumeric (pr_number)) return false; 
				if (! isNumeric (re_hours)) return false; 
			} 

      return true;
    }

  } // webpmResource

} // resourceMgr 

