// dojo.require {
dojo.require("dojo.parser");
dojo.require("dojo.data.ItemFileWriteStore");
dojo.require("dojo.date.locale");
dojo.require("dojo.date.stamp");

dojo.require("dijit.dijit");
dojo.require("dijit.Declaration");
dojo.require("dijit.form.Button");
dojo.require("dijit.Menu");
dojo.require("dijit.Tree");
dojo.require("dijit.Tooltip");
dojo.require("dijit.Dialog");
dojo.require("dijit.Toolbar");
dojo.require("dijit._Calendar");
dojo.require("dijit.ColorPalette");
dojo.require("dijit.Editor");
dojo.require("dijit._editor.plugins.LinkDialog");
dojo.require("dijit._editor.plugins.FontChoice");
dojo.require("dijit._editor.plugins.AlwaysShowToolbar"); 
dojo.require("dijit.ProgressBar");
dojo.require("dijit.TitlePane"); 
dojo.require("dijit.InlineEditBox"); 

dojo.require("dijit.form.ComboBox");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.form.Textarea");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.ValidationTextBox"); 
dojo.require("dijit.form.NumberTextBox"); 
dojo.require("dijit.form.NumberSpinner"); 
dojo.require("dijit.form.ComboBox");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dijit.form.Textarea");
dojo.require("dijit.form.Form")
dojo.require("dijit.form.CurrencyTextBox");
dojo.require("dijit.form.DateTextBox"); 

dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.AccordionContainer");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.ContentPane");

dojo.require("dojox.grid.DataGrid");
dojo.require("dojox.widget.FisheyeLite");
dojo.require("dojox.analytics.Urchin");
dojo.require("dojox.data.CsvStore"); 
dojo.require("dojox.data.JsonRestStore"); 
dojo.require("dojox.widget.Calendar"); 
dojo.require("dojox.widget.CalendarViews"); 
// }

/* System init. */ 

dojo.addOnLoad (function () {

	dojo.parser.parse();
	dijit.setWaiRole(dojo.body(), "application");

	var n = dojo.byId("preLoader");
	dojo.fadeOut({
		node:n,
		duration:720,
		onEnd:function(){
			// dojo._destroyElement(n); 
			dojo.style(n,"display","none");
		}
	}).play(); 

	// make tooltips go down (from buttons on toolbar) rather than to the right
	dijit.Tooltip.defaultPosition = ["above", "below"];

	// build the system messages tab 
	smTab = LoadSystemMessages ();
	if (smTab != null) { 
		dojo.mixin (smTab, 
			{
				title: "System Messages", 
			}
		);

		message.addChild (smTab); 
		message.selectChild (smTab); 
	}

	// init. the cool tree
	cool_tree.init (); 
	dojo.connect(cool_tree.tree, 'onClick', function (item) {
    var done = false;
		var newTab = null; 

		if (cool_tree.store.getValue (item, "id") == null) 
			done = true; 

    dojo.forEach (message.getChildren (), function (child) {
      if (child.attr("title") == cool_tree.store.getValue (item, "id")) {
        message.selectChild (child);
        done = true;
      }
		}); 

   	if (done == false) {

   	  if (cool_tree.store.getValue (item, "id").substring (2,0) == "bc") {
        newTab = LoadBusinessCase (cool_tree.store.getValue (item, "id"));
      } else if (cool_tree.store.getValue(item, "id").substring (2,0) == "pr") {
        newTab = LoadProject (cool_tree.store.getValue (item, "id"));
      } else if (cool_tree.store.getValue (item, "id").substring (2,0) == "re") {
        newTab = LoadResource(cool_tree.store.getValue (item, "id"));
      }

			if (newTab != null) { 
      	dojo.mixin(newTab,
      		{
          	title: cool_tree.store.getValue (item, "label"),
          	closable: true,
        	}
      	);

      	message.addChild(newTab);
      	message.selectChild(newTab);
			} 
   	}
	});

	addSystemMessage ('System init. -- welcome to WebPM.'); 
});

/* The cool tree */ 

var cool_tree = {
	store: null, 
  model: null, 
  tree: null, 
	forceError: false,

	init: function () {
		this.store = new dojox.data.JsonRestStore ({ target: "tree/", labelAttribute: "label" }); 
		this.model = new dijit.tree.ForestStoreModel ({ 
			store: this.store, 
			deferItemLoadingUntilExpand: true, 
			query: "root", 
			childrenAttrs: ["folders"], 
			onNewItem: function (item, parent) { 
				this._requeryTop (); 
			} 
		}); 
		this.tree = new dijit.Tree ({ 
			model: this.model, 
			label: "WebPM", 
			persist: false
		}, 'tree'); 
		this.tree.startup (); 
	}, 
	get: function () { 
	}, 
	put: function (id, label) { 
		this.store.fetchItemByIdentity ({ 
			identity: id, 
			onItem: dojo.hitch(this.store, function (item) { 
				this.setValue (item, 'label', label); 
				this.save ({ 
					onComplete: function () { 
						addSystemMessage (id + ': Update of item ' + id + ' successful.'); 
					}, 
					onError: function (error) { 
					} 
				});
			}), 
			onError: function (error) { 
				addSystemMessage (id + ': Fetching item failed with: ' + error); 
			}  
		}); 
	}, 
	del: function (id) { 
    this.store.fetchItemByIdentity ({
      identity: id,
      onItem:dojo.hitch(this.store, function (item) {
        this.deleteItem (item);
        this.save ({
          onComplete: function (item) {
						message.closeChild (message.selectedChildWidget);
          },
          onError: function (error) {
            app.store.revert (); 
						addSystemMessage (id + ': Delete from tree failed with: ' + error); 
          }
        }); 
      }),
      onError: function (error) {
				addSystemMessage (id + ': Fetching item failed with: ' + error); 
      }
    });
	},
	postBusinessCase: function (bcId, bcLabel) {
		this.store.fetchItemByIdentity ({
			identity: 'business_cases',
			onItem: dojo.hitch (this, function (item) {
				this.model.newItem ({
					id: bcId,
					label: bcLabel
				}, item); 
				this.store.save ({
					onComplete: function () {
						//addSystemMessage (bcId + ': Added to tree.'); 
						//bc_name_store.newItem ({ bc_number: bcId, bc_name: bcLabel }); 
					},
					onError: function (error) {
						addSystemMessage (bcId + ': Add to tree failed with: ' + error); 
					}
				});
			}),
			onError: function (error) {
				addSystemMessage (bcId + ': Fetching item failed with: ' + error); 
			}
		});
	}, 
	postProject: function (bcId, prId, prLabel) {
		this.store.fetchItemByIdentity ({
			identity: bcId,
			onItem: dojo.hitch (this, function (item) {
				this.model.newItem ({
					id: prId, 
					label: prLabel 
				}, item); 
				this.store.save ({
					onComplete: function () {
						//addSystemMessage (prId + ': Added to tree.'); 
						//pr_name_store.newItem ({ pr_number: prId, pr_name: prLabel }); 
					},
					onError: function (error) {
						addSystemMessage (prId + ': Add to tree failed with: ' + error); 
					}
				});
			}),
			onError: function (error) {
				addSystemMessage (prId + ': Fetching item failed with: ' + error); 
			}
		});
	}, 
	postResource: function (prId, reId, reLabel) { 
		this.store.fetchItemByIdentity({
			identity: prId, 
			onItem: dojo.hitch (this, function (item) {
				this.model.newItem ({
					id: reId,
					label: reLabel
				}, item); 
				this.store.save ({
					onComplete: function () {
						addSystemMessage (reId + ': Added to tree.'); 
						//re_name_store.newItem ({ re_number: reId, re_name: reLabel }); 
					},
					onError: function (error) {
						addSystemMessage (reId + ': Add to tree failed with: ' + error); 
					}
				});
			}),
			onError: function (error) {
				addSystemMessage (reId + ': Fetching item failed with: ' + error); 
			}
		});
	} 
}; 

/* System messaging */ 

var system_message_store = new dojo.data.ItemFileWriteStore ({ 
	jsId: "system_message_store", 
	url: "json/empty_system_messages.json", 
}); 
var LoadSystemMessages = function () { 

	var system_message_grid_layout = [
		{ field: 'id',			name: 'Id',				width: '10' }, 
		{ field: 'time',		name: 'Time',			width: '10' }, 
		{ field: 'message',	name: 'Message',	width: 'auto' }
	];
  var system_message_grid = new dojox.grid.DataGrid ({
      query: { time: '*' },
      store: system_message_store,
      clientSort: true,
      structure: system_message_grid_layout, 
      region: "center"
  });
	var borderContainer = new dijit.layout.BorderContainer ({ 
	}); 
  borderContainer.addChild (system_message_grid);

	return borderContainer; 
	
}
var nextMessageId = 0;
var addSystemMessage = function (msg) { 
		system_message_store.newItem ({ id: nextMessageId++, time: getCurrentTime (), message: msg }); 
}
var getCurrentTime = function () { 
		var d = new Date (); 
		var cur_hour = d.getHours (); 
		var cur_minutes = d.getMinutes (); 
		cur_minutes = cur_minutes + "";
		if (cur_minutes.length == 1) 
			cur_minutes = "0" + cur_minutes; 

		return cur_hour + ':' + cur_minutes; 
}

/* Load/add/edit/save/reload fns */ 

var LoadBusinessCase = function (bcId) { 

	var bc_store = new dojo.data.ItemFileWriteStore ({
		jsId: "bc_store", 
		url: "http://webpm:8080/webpm/businessCaseMgr?q=" + bcId, 
		clearOnClose: true, 
		urlPreventCache: true
	}); 
	var borderContainer = new dijit.layout.BorderContainer ({
		closeable: true
	}); 
	var topContent = new dijit.layout.ContentPane ({
		region: "top",
		content: bcm_top_form.replace(/\${bcId}/g, bcId), 
		style: "z-index: 10;" 
	}); 
	var bottomContent = new dijit.layout.ContentPane ({
		region: "bottom",
		content: bcm_bottom_form.replace(/\${bcId}/g, bcId), 
		style: "text-align: center;"
	}); 
	function bc_properties_read (items) { 
		dojo.byId('bc_name_' + bcId).value = bc_store.getValue (items[0], "name"); 
		dojo.byId('bc_number_' + bcId).value = bc_store.getValue (items[0], "number"); 
		dojo.byId('bc_desc_' + bcId).value = bc_store.getValue (items[0], "desc"); 

		var bc_projects_store = new dojo.data.ItemFileReadStore ({ 
			url: "http://webpm:8080/webpm/projectMgr?b=" + bcId
		}); 
		var bc_projects_grid_layout = [
			{ field: 'number', 			name: 'P#', 				width: 'auto' }, 
			{ field: 'name',				name: 'Name', 			width: 'auto' }, 
			{ field: 'manager', 		name: 'Manager', 		width: 'auto' }, 
			{ field: 'poc', 				name: 'POC', 				width: 'auto' }, 
			{ field: 'sponsor', 		name: 'Sponsor', 		width: 'auto' }, 

			{ field: 'sponsoring_component', name: 'Component', width: 'auto' }, 

			{ field: 'start_date',	name: 'Start date',	width: 'auto' }, 
			{ field: 'end_date', 		name: 'End date', 	width: 'auto' }, 
			{ field: 'status', 			name: 'Status', 		width: 'auto' }, 
			{ field: 'hours',				name: 'Hours',			width: 'auto' }, 
			{ field: 'amount', 			name: 'Amount',			width: 'auto' } 
		]; 
		var bc_projects_grid = new dojox.grid.DataGrid ({
			query: { id: '*' }, 
			store: bc_projects_store, 
			clientSort: true, 
			structure: bc_projects_grid_layout, 
			region: "center"
		}); 

		borderContainer.addChild (bc_projects_grid); 
	}; 
	function read_error (errData, request) { 
		addSystemMessage ('Request for ' + request + ' failed wtih ' + error); 
	}; 
	bc_store.fetch ({
		onComplete: bc_properties_read,
		onError: read_error 
	}); 
	borderContainer.addChild (topContent); 
	borderContainer.addChild (bottomContent); 

	return borderContainer; 
}
var LoadProject = function (prId) { 

	var pr_store = new dojo.data.ItemFileWriteStore ({
		jsId: "pr_store", 
		url: "http://webpm:8080/webpm/projectMgr?q=" + prId, 
		clearOnClose: true, 
		urlPreventCache: true
	}); 
	var borderContainer = new dijit.layout.BorderContainer ({ closeable: true }); 
	var topContent = new dijit.layout.ContentPane ({
		region: "top", 
		content: prm_top_form.replace(/\${prId}/g, prId), 
		style: "height: 320px;" 
	}); 
	var bottomContent = new dijit.layout.ContentPane ({
		region: "bottom", 
		content: prm_bottom_form.replace(/\${prId}/g, prId),  
		//style: "height: 32px;"
		style: "text-align: center;"
	}); 
	function pr_properties_read (items) { 
		dojo.byId ('pr_name_' + prId).value = pr_store.getValue (items[0], "name"); 
		dojo.byId ('pr_number_' + prId).value = pr_store.getValue (items[0], "number"); 
		dojo.byId ('pr_business_case_' + prId).value = pr_store.getValue (items[0], "bc_number"); 
		dojo.byId ('pr_manager_' + prId).value = pr_store.getValue (items[0], "manager"); 
		dojo.byId ('pr_poc_' + prId).value = pr_store.getValue (items[0], "poc"); 
		dojo.byId ('pr_sponsor_' + prId).value = pr_store.getValue (items[0], "sponsor"); 
		dojo.byId ('pr_start_date_' + prId).value = pr_store.getValue (items[0], "start_date"); 
		dojo.byId ('pr_end_date_' + prId).value = pr_store.getValue (items[0], "end_date"); 
		dojo.byId ('pr_status_' + prId).value = pr_store.getValue (items[0], "status"); 
		dojo.byId ('pr_desc_' + prId).value = pr_store.getValue (items[0], "desc"); 
		dojo.byId ('pr_total_hours_' + prId).value = pr_store.getValue (items[0], "hours"); 
		dojo.byId ('pr_total_amount_' + prId).value = pr_store.getValue (items[0], "amount"); 

		// meh 
		dojo.byId ('pr_sponsoring_component_' + prId).value = pr_store.getValue (items[0], "sponsoring_component"); 

		var pr_resources_store = new dojo.data.ItemFileReadStore ({ 
			url: "http://webpm:8080/webpm/resourceMgr?p=" + prId
		}); 
		var pr_resources_grid_layout = [
			{ field: 'number', 			name: 'R#', 				width: 'auto' }, 
			{ field: 'name',				name: 'Name', 			width: 'auto' }, 
			{ field: 'hours',				name: 'Hours',			width: 'auto' }
		]; 
		var pr_resources_grid = new dojox.grid.DataGrid ({
			query: { id: '*' }, 
			store: pr_resources_store, 
			clientSort: true, 
			structure: pr_resources_grid_layout, 
			title: "Resources", 
		}); 

		var pr_amounts_store = new dojo.data.ItemFileReadStore ({ 
			url: "http://webpm:8080/webpm/projectMgr?a=" + prId 
		}); 
		var pr_amounts_grid_layout = [
			{ field: 'year',				name: 'Year',				width: 'auto' }, 
			{ field: 'amount',			name: 'Amount',			width: 'auth' }
		];
		var pr_amounts_grid = new dojox.grid.DataGrid ({
			query: { id: '*' }, 
			store: pr_amounts_store, 
			clientSort: true, 
			structure: pr_amounts_grid_layout, 
			title: "Amounts", 
		}); 

		var pr_data_tabs = new dijit.layout.TabContainer ({ region: "center" }); 
		pr_data_tabs.addChild (pr_resources_grid); 
		pr_data_tabs.addChild (pr_amounts_grid); 
		borderContainer.addChild (pr_data_tabs); 
		
	}; 

	function read_error (errData, request) { 
		addSystemMessage ('Request for ' + request + ' failed wtih ' + error); 
	}; 
	pr_store.fetch ({
		onComplete: pr_properties_read,
		onError: read_error 
	}); 
	borderContainer.addChild (topContent); 
	borderContainer.addChild (bottomContent); 

	return borderContainer; 

/* 
	function completed (items) { 
		dojo.byId ('pr_name_' + prId).value = pr_store.getValue (items[0], "name"); 
		dojo.byId ('pr_number_' + prId).value = pr_store.getValue (items[0], "number"); 
		dojo.byId ('pr_business_case_' + prId).value = pr_store.getValue (items[0], "bc_number"); 
		dojo.byId ('pr_manager_' + prId).value = pr_store.getValue (items[0], "manager"); 
		dojo.byId ('pr_poc_' + prId).value = pr_store.getValue (items[0], "poc"); 
		dojo.byId ('pr_sponsor_' + prId).value = pr_store.getValue (items[0], "sponsor"); 
		dojo.byId ('pr_start_date_' + prId).value = pr_store.getValue (items[0], "start_date"); 
		dojo.byId ('pr_end_date_' + prId).value = pr_store.getValue (items[0], "end_date"); 
		dojo.byId ('pr_status_' + prId).value = pr_store.getValue (items[0], "status"); 
		dojo.byId ('pr_desc_' + prId).value = pr_store.getValue (items[0], "desc"); 
	}; 
	function read_error (errData, request) { 
		addSystemMessage ('Request for ' + request + ' failed with ' + error); 
	}; 

	pr_store.fetch ({
		onComplete: completed,
		onError: read_error
	}); 

	borderContainer.addChild (topContent); 
	borderContainer.addChild (bottomContent); 

	return borderContainer; 
*/
}
var LoadResource = function (reId) { 

	var re_store = new dojo.data.ItemFileWriteStore ({
		jsId: "re_store", 
		url: "http://webpm:8080/webpm/resourceMgr?q=" + reId, 
		clearOnClose: true, 
		urlPreventCache: true
	}); 
	var borderContainer = new dijit.layout.BorderContainer ({ closeable: true }); 
	var topContent = new dijit.layout.ContentPane ({
		region: "top", 
		content: rem_top_form.replace(/\${reId}/g, reId),
		style: ";"
	}); 
	var bottomContent = new dijit.layout.ContentPane ({
		region: "bottom", 
		content: rem_bottom_form.replace(/\${reId}/g, reId),
		style: "text-align: center;"
	}); 
  function re_properties_read (items) {
    dojo.byId('re_name_' + reId).value = re_store.getValue (items[0], "name");
    dojo.byId('re_number_' + reId).value = re_store.getValue (items[0], "number"); 
    dojo.byId('re_desc_' + reId).value = re_store.getValue (items[0], "desc"); 

    var re_assignments_store = new dojo.data.ItemFileReadStore ({ 
      url: "http://webpm:8080/webpm/resourceMgr?a=" + reId
    }); 
    var re_assignments_grid_layout = [
      { field: 'number',      name: 'P#',         width: 'auto' }, 
      { field: 'name',        name: 'Name',       width: 'auto' }, 
      { field: 'hours',       name: 'Hours',      width: 'auto' }
    ]; 
    var re_assignments_grid = new dojox.grid.DataGrid ({
      query: { id: '*' }, 
      store: re_assignments_store, 
      clientSort: true, 
      structure: re_assignments_grid_layout, 
      region: "center"
    }); 

    borderContainer.addChild (re_assignments_grid); 
  };
  function read_error (errData, request) { 
		addSystemMessage ('Request for ' + request + ' failed wtih ' + error); 
  };
  re_store.fetch ({
    onComplete: re_properties_read,
    onError: read_error
  });
  borderContainer.addChild (topContent);
  borderContainer.addChild (bottomContent);

  return borderContainer;

}
var LoadUser = function (usId) { 

	var borderContainer = new dijit.layout.BorderContainer ({ closeable: true }); 
	var topContent = new dijit.layout.ContentPane ({
		region: "top", 
		content: "" 
	}); 
	var centerContent = new dijit.layout.ContentPane ({
		region: "center", 
		content: "" 
	}); 
	var bottomContent = new dijit.layout.ContentPane ({
		region: "bottom", 
		content: "" 
	}); 

	borderContainer.addChild (topContent); 
	borderContainer.addChild (centerContent); 
	borderContainer.addChild (bottomContent); 

	return borderContainer; 
}
var LoadSearchResults = function () { 

	var borderContainer = new dijit.layout.BorderContainer ({ closeable: true }); 
	var topContent = new dijit.layout.ContentPane ({
		region: "top", 
		content: "" 
	}); 
	var centerContent = new dijit.layout.ContentPane ({
		region: "center", 
		content: "" 
	}); 
	var bottomContent = new dijit.layout.ContentPane ({
		region: "bottom", 
		content: "" 
	}); 

	borderContainer.addChild (topContent); 
	borderContainer.addChild (centerContent); 
	borderContainer.addChild (bottomContent); 

	return borderContainer; 
}
var addBusinessCase = function (bcId, bcLabel) { 

  var xhrArgs = {
    form: dojo.byId ("new_bc_form"),
    url: "http://webpm:8080/webpm/businessCaseMgr",
    handleAs: "text",
    load: function (data) {
			cool_tree.postBusinessCase (bcId, bcLabel); 
			addSystemMessage ('Adding ' + bcLabel + ' to database.'); 
    },
    error: function (error, ioargs) {
			addSystemMessage (bcId + ': Failed to add ' + bcLabel + ' to database'); 
			addSystemMessage (bcId + ': ' + error); 
    }
  };

  var deferred = dojo.xhrPost (xhrArgs);
}
var addProject = function (bcId, prId, prLabel) { 

  var xhrArgs = {
    form: dojo.byId ("new_pr_form"),
    url: "http://webpm:8080/webpm/projectMgr",
    handleAs: "text",
    load: function (data) {
			cool_tree.postProject (bcId, prId, prLabel); 
      project_amounts.revert ();
      resource_allocs.revert ();
			addSystemMessage ('Adding ' + prLabel + ' to database.');
    },
    error: function (error) {
			addSystemMessage (prId + ': Failed to add ' + prLabel + ' to database'); 
			addSystemMessage (prId + ': ' + error); 
    }
  };

  var deferred = dojo.xhrPost(xhrArgs);

}
var addResource = function (prId, reId, reLabel) { 

  var xhrArgs = {
    form: dojo.byId ("new_re_form"),
    url: "http://webpm:8080/webpm/resourceMgr",
    handleAs: "text",
    load: function (data) {
      cool_tree.postResource (prId, reId, reLabel);
      addSystemMessage ('Adding ' + reLabel + ' to database.');
    },
    error: function (error, ioargs) {
      addSystemMessage (reId + ': Failed to add ' + reLabel + ' to database');
      addSystemMessage (reId + ': ' + error);
    }
  };

  var deferred = dojo.xhrPost (xhrArgs);

}
var modifyResource = function (reId, reLabel) { 
	cool_tree.put (reId, reLabel); 
	message.closeChild (message.selectedChildWidget); 
} 
var modifyBusinessCase = function (bcId, bcLabel) { 
	cool_tree.put (bcId, bcLabel); 
	message.closeChild (message.selectedChildWidget); 
} 
var modifyProject = function (prId, prLabel) { 
	cool_tree.put (prId, prLabel); 
	message.closeChild (message.selectedChildWidget); 
}
var deleteBusinessCase = function (bcId) { 
	cool_tree.store.fetchItemByIdentity({
		identity: bcId,
		onItem: dojo.hitch(cool_tree.store, function(item) {
			if (confirm ("Are you sure?  (This operation cannot be undone!)")) {
				cool_tree.del (bcId); 
				//message.closeChild(message.selectedChildWidget);
			} 
		}),
		onError: function (error, request) {
			addSystemMessage ('Request for ' + request + ' failed wtih ' + error); 
		}
	}); 
}
var deleteProject = function (prId) { 
	cool_tree.store.fetchItemByIdentity({
		identity: prId,
		onItem: dojo.hitch(cool_tree.store, function(item) {
			if (confirm ("Are you sure? (This operation cannot be undone!)")) {
				cool_tree.del (prId); 
				//message.closeChild(message.selectedChildWidget);
			} 
		}),
		onError: function (error, request) {
			addSystemMessage ('Request for ' + request + ' failed wtih ' + error); 
		}
	});
}
var deleteResource = function (reId) { 
	if (confirm ("Are you sure?  (This operation cannot be undone!)")) {
		cool_tree.del (reId); 
	} 
}
var editBusinessCase = function (bcId) { 

	dijit.byId ('edit_bc_name').setValue (dijit.byId ('bc_name_' + bcId).attr ('value')); 
	dijit.byId ('edit_bc_number').setValue (dijit.byId ('bc_number_' + bcId).attr ('value')); 
	dijit.byId ('edit_bc_desc').setValue (dijit.byId ('bc_desc_' + bcId).attr ('value')); 

	dijit.byId ('edit_bc_dialog').show (); 

}
var editProject = function (prId) { 

	dijit.byId ('edit_pr_name').setValue (dijit.byId ('pr_name_' + prId).attr ('value')); 
	dijit.byId ('edit_pr_number').setValue (dijit.byId ('pr_number_' + prId).attr ('value')); 
	dijit.byId ('edit_pr_business_case').attr('displayedValue', dijit.byId ('pr_business_case_' + prId).attr ('value')); 
	dijit.byId ('edit_pr_mgr').setValue (dijit.byId ('pr_manager_' + prId).attr ('value')); 
	dijit.byId ('edit_pr_poc').setValue (dijit.byId ('pr_poc_' + prId).attr ('value')); 
	dijit.byId ('edit_pr_sponsor').setValue (dijit.byId ('pr_sponsor_' + prId).attr ('value')); 
	dijit.byId ('edit_pr_sponsoring_component').setValue (dijit.byId ('pr_sponsoring_component_' + prId).attr ('value')); 

	/* we weren't able to get this to work right (meh) */
	//dijit.byId ('edit_pr_start_date').setValue (dijit.byId ('pr_start_date_' + prId).attr ('value')); 
	//dijit.byId ('edit_pr_end_date').setValue (dijit.byId ('pr_end_date_' + prId).attr ('value')); 

	dijit.byId ('edit_pr_status').setValue (dijit.byId ('pr_status_' + prId).attr ('value')); 
	dijit.byId ('edit_pr_amount').setValue (dijit.byId ('pr_total_amount_' + prId).attr ('value')); 
	dijit.byId ('edit_pr_resource_hours').setValue (dijit.byId ('pr_total_hours_' + prId).attr ('value')); 
	dijit.byId ('edit_pr_desc').setValue (dijit.byId ('pr_desc_' + prId).attr ('value')); 

	dijit.byId ('edit_pr_dialog').show (); 

}
var editResource = function (reId) { 

	dijit.byId ('edit_re_name').setValue (dijit.byId ('re_name_' + reId).attr ('value')); 
	dijit.byId ('edit_re_number').setValue (dijit.byId ('re_number_' + reId).attr ('value')); 
	dijit.byId ('edit_re_desc').setValue (dijit.byId ('re_desc_' + reId).attr ('value')); 

	dijit.byId ('edit_re_dialog').show (); 

}
var saveBusinessCase = function (bcId, newBcLabel) { 
	cool_tree.put (bcId, newBcLabel); 
}
var saveProject = function (prId) { 
	cool_tree.put (prId); 
}
var saveResource = function (reId) {
	cool_tree.put (reId); 
}
var reloadBusinessCase = function (bcId) { 
}
var reloadProject = function (bcId) { 
}
var reloadResource = function (bcId) { 
}

/* Reporting subsystem support fns */ 

function roadmap () { 

}
function timeline () { 

}
function work_initiation_plan () { 
	var wip_sd = "";
	wip_sd += dijit.byId ('wip_start_date').attr ('value'); 
	var ms = wip_sd.substring (4,7); 
	var ys = wip_sd.substring (11,15); 
	var ds = wip_sd.substring (8,10); 
	ms = month_to_num (ms);

	var wip_ed = "";
	wip_ed += dijit.byId ('wip_end_date').attr ('value'); 
	var me = wip_ed.substring (4,7); 
	var ye = wip_ed.substring (11,15); 
	var de = wip_ed.substring (8,10); 
	me = month_to_num (me);
	window.open ('http://webpm:8080/webpm/work_init_plan.pdf?report=initiationPlan&ys=' + ys + '&ms=' + ms + '&ds=' + ds + '&ye=' + ye + '&me=' + me + '&de=' + de, '_blank'); 
}

function month_to_num(month)
{

	var monthArr = new Array();
	monthArr['Jan'] = 1;
	monthArr['Feb'] = 2;
	monthArr['Mar'] = 3;
	monthArr['Apr'] = 4;
	monthArr['May'] = 5;
	monthArr['Jun'] = 6;
	monthArr['Jul'] = 7;
	monthArr['Aug'] = 8;
	monthArr['Sep'] = 9;
	monthArr['Oct'] = 10;
	monthArr['Nov'] = 11;
	monthArr['Dec'] = 12;

	return (monthArr [month] - 1); 
}
/* Utility fns */ 

function testClose (pane, tab) {
  return confirm("Are you sure you want to leave your changes?");
}
var requestId = ""; 
var project_amounts = new dojo.data.ItemFileWriteStore ({ 
	url: "json/empty_project_amounts.json"
}); 
var formatDate = function (inDatum) {
    return dojo.date.locale.format(dojo.date.stamp.fromISOString(inDatum), {selector: "date"});
}
var formatAmount = function (inDatum) {
	var txt = new String(inDatum); 
	switch (txt.lastIndexOf('.')) {
		case (-1): 
			return '\$' + txt + '.00'; 
			break; 
		case (txt.length - 2): 
			return '\$' + txt + '0'; 
		default: 
			return '\$' + txt; 
		 
	}
}

